//Copyright (c) 1998, Arthur Gittleman
//This example is provided WITHOUT ANY WARRANTY either expressed or implied.

/* Implements the Runnable
 * interface rather than extending Thread.
 * Note: Can't be started from outside
 */
 
// Prepared by Dr. Spiegel

import java.io.*;

public class NameUsingThread implements Runnable {
  private int time;
  private Thread thread;
          

  public NameUsingThread(String n, int t) {
    time=t; 
    thread = new Thread(this,n);
    thread.start();  
  }

  public void run() {
    for (int i=1;i<=5;i++) {
      System.out.println(thread.getName() + " " + i);
      try {
        Thread.sleep(time);
      } catch (InterruptedException e) {return;}
    }
  }

  public static void main(String argv[]) {
    NameUsingThread bonnie = new NameUsingThread("Bonnie",1000);
    NameUsingThread clyde =  new NameUsingThread("Clyde",700);
    for (int i=1;i<=5;i++) {
      System.out.println(Thread.currentThread().getName() + " " + i);
      try {
        Thread.sleep(1100);
      } catch (InterruptedException e) {return;}
    }
    // can't do this; NameUsingThread is NOT a THread
    // bonnie.start();
  }
}